﻿// SystemColorPicker.jsx
// Добавление образца цвета из палитры операционной системы в список цветов индизайна

#target "indesign"
#targetengine "colorPicker"
//var pick=$.colorPicker (0x0f4d21);

var pick=$.colorPicker();
if(pick==-1){ exit(); }
var pick16=pick.toString(16);
// строка описания цвета должна состоять из шести символов
if (pick16.length == 5) pick16 = "0" + pick16;
if (pick16.length == 4) pick16 = "00" + pick16;
if (pick16.length == 3) pick16 = "000" + pick16;
if (pick16.length == 2) pick16 = "0000" + pick16;
if (pick16.length == 1) pick16 = "00000" + pick16;
var mySelectedColorPattern=app.documents[0].colors.add ({ space:ColorSpace.RGB, colorValue:[parseInt(pick16.substr (0, 2), 16),parseInt(pick16.substr (2, 2), 16),parseInt(pick16.substr (4, 2), 16)]})
// добавили выбранный образец в палитру цветов. Позже, после получения RGB- и CMYK-пропорций цвета, этот mySelectedColorPattern будет удалён
mySelectedColorPattern.space=ColorSpace.RGB; // предположим, что это RGB
var rgb = mySelectedColorPattern.colorValue;
var myValueR=Math.round(rgb[0]);
var myValueG=Math.round(rgb[1]);
var myValueB=Math.round(rgb[2]);
var myInfoRGB = " (R=" + myValueR + " G=" + myValueG + " B=" + myValueB +")";
mySelectedColorPattern.space=ColorSpace.CMYK;  // предположим, что это CMYK
var cmyk=mySelectedColorPattern.colorValue;
var myValueC=Math.round(cmyk[0]);
var myValueM=Math.round(cmyk[1]);
var myValueY=Math.round(cmyk[2]);
var myValueK=Math.round(cmyk[3]);
var myInfoCMYK = " (C=" + myValueC + " M=" + myValueM + " Y=" + myValueY + " K=" + myValueK +")";
mySelectedColorPattern.remove(); // RGB и CMYK значения выбранного образца известны. Теперь его надо удалить из палитры
var w = new Window ("dialog","\u00A0Определение модели выбранного цвета  (25.10.2011)");
w.alignChildren = "left";
myModelGroup = w.add ("group");
myModelGroup.orientation = "row";
var rgbModel = myModelGroup.add ("radiobutton", undefined, "RGB" + myInfoRGB); 
myModelGroup.add ("statictext",  {x:0, y:0, width:5, height:10}, "");
var cmykModel = myModelGroup.add ("radiobutton",undefined, "CMYK" + myInfoCMYK);
cmykModel.value = true;
var myInfoAndButtonGroup = w.add ("group");
var myInfoGroup = myInfoAndButtonGroup.add ("group");
myInfoGroup.add ("statictext", undefined , "© adobeindesign.ru,\u00A02011 г."); 
var myButtonGroup = myInfoAndButtonGroup.add ("panel");
myButtonGroup.orientation = "row";
myButtonGroup.alignment = "right";
myOK = myButtonGroup.add ("button", undefined, "OK");
myCancel = myButtonGroup.add ("button", undefined, "Cancel");
w.center();
rgbModel.onClick = function () {
	rgbModel.value = true;
	cmykModel.value = false;
}
cmykModel.onClick = function () {
	rgbModel.value = false;
	cmykModel.value = true;
}
myCancel.onClick = function () {
	w.close();
}
if (w.show () == 1) { // OK
	if (rgbModel.value == true) {
		var mySelectedColorPatternRGB=app.documents[0].colors.add();
		mySelectedColorPatternRGB.space=ColorSpace.RGB;
		mySelectedColorPatternRGB.colorValue=[myValueR, myValueG, myValueB];
		exit();
	}
	if (cmykModel.value == true) { 
		var mySelectedColorPatternCMYK=app.documents[0].colors.add();
		mySelectedColorPatternCMYK.space=ColorSpace.CMYK;
		mySelectedColorPatternCMYK.colorValue=[myValueC, myValueM, myValueY, myValueK];
		exit();
	}	
} // OK
